﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using MEFedMVVM.ViewModelLocator;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using GalaSoft.MvvmLight.Messaging;
using System.Collections.Generic;

namespace SwheatExample1
{
    [ExportViewModel("MainPage")]
    public class MainPageViewModel : ViewModelBase
    {
        public RelayCommand Save {get; private set;}

        public MainPageViewModel()
        {
            Save = new RelayCommand(SaveStuff);
        }
        public void SaveStuff()
        {
            string errorMessage;
            //errorMessage = do save stuff
            errorMessage = "Demo error message " + Guid.NewGuid().ToString();
            if (!string.IsNullOrWhiteSpace(errorMessage))
            {
                DialogMessage message = new DialogMessage(errorMessage, HandleErrorMessageReturn) { Button = MessageBoxButton.OK, Caption="Error" };
                Messenger.Default.Send(message);
            }
        }
        public void HandleErrorMessageReturn(MessageBoxResult result)
        {
            List<string> dummyData = new List<String>();
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            dummyData.Add(Guid.NewGuid().ToString());
            ConfirmOverwriteMessage message = new ConfirmOverwriteMessage(c =>
            {
                
                    if (c)
                        Messenger.Default.Send(new DialogMessage("Are you sure you want to save?", HandleSaveConfirmation) { Button = MessageBoxButton.OKCancel, Caption = "Confirm" });
                    else
                        Messenger.Default.Send(new DialogMessage("Save Cancelled", NullResult) { Button = MessageBoxButton.OK, Caption = "Result" });
                });
            
            message.OverrwrittenData = dummyData;
            Messenger.Default.Send(message);
        }

        public void HandleSaveConfirmation(MessageBoxResult result)
        {
            
                   if (result == MessageBoxResult.Yes)
                       Messenger.Default.Send(new DialogMessage("Save Complete", NullResult) { Button = MessageBoxButton.OK, Caption = "Result" });
                   else
                       Messenger.Default.Send(new DialogMessage("Save Cancelled", NullResult) { Button = MessageBoxButton.OK, Caption = "Result" });
              
        }
        public void NullResult(MessageBoxResult result)
        {
            
        }

    }
}
